
#ifndef BMLPA_UNWEIGHTED_H
#define BMLPA_UNWEIGHTED_H


#include "graph_unweighted.h"

using namespace std;

class Algorithm{
public:
	Algorithm(Graph *g);

public:
	void roughcores(map<unsigned int,set<unsigned int> > &roughcore);

	void initbmlpa();
	void propagate_bmlpa(unsigned int x);

	void normalize(unsigned int x);
	void idl(vector< map<unsigned int, double> >& l, vector<unsigned int>& ids);
	void idx(map<unsigned int, double>& lx, vector<unsigned int>& ids);
	void count();
	void mc(map<unsigned int, int>& newmin);

	void execute_bmlpa();

	void removeSubs();

	void splitDisconnectComs();
	void saveResult(string filepath, string type);

	void setp(double p);


private:
	map< unsigned int, vector<unsigned int> > coms;
	map< unsigned int, vector<unsigned int> > sub;
	Graph *g;
	vector< map<unsigned int, double> > source;
	vector< map<unsigned int, double> > dest;
	map<unsigned int, int> counts;
	map<unsigned int, int> min;

	double p;
	int k;
	map<unsigned int,set<unsigned int> > roughcore;

};
#endif //BMLPA_UNWEIGHTED_H
